/*
 * Created on Dec 1, 2004
 */
package weka.classifiers.ucd.biased;

/**
 * Interface for classifiers that can be biased towards high precision
 * for a preferred class.
 * @author andreas
 */
public interface BiasedClassifier {

    /**
     * @return The class index of the preferred class.
     */
    public abstract int getPreferredClassIndex();

    /**
     * @param i The class index for the preferred class.
     */
    public abstract void setPreferredClassIndex(int i);
    
    /**
	 * @return The current bias.
	 */
	public abstract double getBiasStrength();
	
	/**
	 * @param d The bias. Should be in the range between 0 (no bias) to 1.
	 * A classifier may decide to allow values > 1 for the bias strength,
	 * if the bias strength does not have a natural maximum. In that case,
	 * 1 should be a "reasonable" value for a very high bias.
	 */
	public abstract void setBiasStrength(double d);

}