/*
 * Created on Nov 29, 2004
 */
package weka.classifiers.ucd.biased;

import weka.core.Instance;
import weka.core.Instances;

/**
 * @author andreas
 */
public class UndersamplingBiasedClassifier extends BiasedClassifierImpl {

    double epsilon = 0.00001;
    
    public UndersamplingBiasedClassifier() {
        // different default bias
        bias = 0.9;
    }
    
    /* (non-Javadoc)
     * @see weka.classifiers.Classifier#buildClassifier(weka.core.Instances)
     */
    public void buildClassifier(Instances originalDataset) throws Exception {
        // The bias has a range between 0 (no bias) and 1, but for this kind
        // of biasing, we need values that are exactly the other way around.
        double n_bias = 1.0 - bias;
		int nInstances = originalDataset.numInstances();
		Instances modifiedDataset = new Instances(originalDataset, 0);
		double counter = 1.0 + n_bias + epsilon;
		for (int m = 0; m < nInstances; m++) {
			Instance i = originalDataset.instance(m); 
			if ((i.classValue() == classIndex)) {
				if (counter > 1) {
					// insert a copy of the instance
					modifiedDataset.add(i);
					counter--;
				}
				counter += n_bias;
			} else {
				// insert a copy of the instance
				modifiedDataset.add(i);
			}
		}
		classifier.buildClassifier(modifiedDataset);
    }
}
