/*
 * Created on Dec 6, 2004
 */
package weka.classifiers.ucd.eval;

import weka.classifiers.evaluation.NominalPrediction;
import weka.core.Instance;

/**
 * @author andreas
 */
public class NominalInstancePrediction extends NominalPrediction implements
        InstancePrediction {
    
    /**
     * The instance that this prediction is based on
     */
    protected Instance instance = null;

    /**
     * @param actual
     * @param distribution
     */
    public NominalInstancePrediction(double actual, double[] distribution) {
        super(actual, distribution);
    }

    /**
     * @param actual
     * @param distribution
     * @param weight
     */
    public NominalInstancePrediction(double actual, double[] distribution,
            double weight) {
        super(actual, distribution, weight);
    }

    /**
     * @param actual
     * @param distribution
     */
    public NominalInstancePrediction(Instance instance, double actual, double[] distribution) {
        super(actual, distribution);
        this.instance = instance;
    }

    /**
     * @param actual
     * @param distribution
     * @param weight
     */
    public NominalInstancePrediction(Instance instance, double actual, double[] distribution,
            double weight) {
        super(actual, distribution, weight);
        this.instance = instance;
    }

    /* (non-Javadoc)
     * @see weka.classifiers.ucd.biased.InstancePrediction#instance()
     */
    public Instance instance() {
        return instance;
    }

}
